#define SkyColor 0 //[0 1 2 3]
//0 Original || 1 Vanilla || 2 Alternative || 3 Classic

#if SkyColor == 0
vec3 sky_c = vec3(0.15, 0.38, 1.00);
vec3 fog_c = vec3(0.15, 0.38, 1.00);
#endif

#if SkyColor == 1
uniform vec3 skyColor;
uniform vec3 fogColor;

vec3 sky_c = pow(skyColor,vec3(2.2));
vec3 fog_c = pow(fogColor,vec3(2.2));
#endif

#if SkyColor == 2
vec3 sky_c = vec3(0.18, 0.36, 0.9);
vec3 fog_c = vec3(0.18, 0.36, 0.9);
#endif

#if SkyColor == 3
vec3 sky_c = vec3(0.1, 0.35, 1.0);
vec3 fog_c = vec3(0.1, 0.35, 1.0);
#endif

vec3 getSkyColor(vec3 fragpos, vec3 light){
vec3 sky_col = sky_c;
vec3 nfragpos = normalize(fragpos);

float NdotUp = dot(nfragpos,upVec);
float NdotS = dot(nfragpos,sunVec);

float top = pow(max(NdotUp,0.1),0.25)*0.48;
float horizon = pow(max(0.9-abs(NdotUp),0.0)*1.05,2.5)*(0.2+0.6*sunVisibility)*(1-rainStrength*0.5);
float lightmix = (pow(max(NdotS,0.0),1.5)*(1-max(NdotUp,0.0))*pow(1.0-tB,3.0) + horizon*0.1*tB)*sunVisibility*(1.0-rainStrength);

#if SkyColor == 1
sky_col = mix(sky_col,fog_c,pow(max(0.8-abs(NdotUp),0.0)*1.25,0.5));
top *= 0.99;
#endif

float mult = 0.5 - top + horizon;

sky_col = (mix(sky_col*pow(max(1-lightmix,0.0),2.0),pow(light,vec3(1.5)),lightmix)*sunVisibility + light_n*0.4);
sky_col = mix(sky_col,pow(mult,0.2)*sky_r*(0.05+0.65*sunVisibility),rainStrength)*mult*(3.0-2.0*eBS);

return sky_col;
}

vec3 getFogColor(vec3 fragpos, vec3 light){
vec3 fog_col = fog_c;
vec3 nfragpos = normalize(fragpos);

float NdotUp = dot(nfragpos,upVec);
float NdotS = dot(nfragpos,sunVec);

float top = pow(max(NdotUp,0.1),0.25)*0.46;
float lightmix = pow(max(NdotS,0.0),1.5)*pow(1.0-tB,3.0)*sunVisibility*(1.0-rainStrength);
float mult = 0.5 - top;

fog_col = (mix(fog_col*pow(max(1-lightmix,0.0),2.0),pow(light,vec3(1.5)),lightmix)*sunVisibility + light_n*0.4)*2.0;
fog_col = mix(fog_col,pow(mult,0.2)*sky_r*(0.04+0.52*sunVisibility),rainStrength)*mult;

return fog_col;
}

vec3 calcFog(vec3 color, vec3 light, vec3 fragpos){
float fog = min(length(fragpos)/(16*(32.0-24.0*rainStrength)*(1.0+sunVisibility)),2.0);
vec3 mixcolor = mix(getFogColor(fragpos,light),getSkyColor(fragpos,light),max(fog-1.0,0.0));
return mix(color,mixcolor,min(fog,1.0)*eBS);
}